/*
   "mcknofbd.mm"
   Simulation of the following system:
   M x^(2) + C x^(1) + K x = u + d
   u = 0, d = 0.5
*/

Func void main()
{
	Real t0,t1;
	Real h,dtsav;
	Matrix x0,TC,XC,UC;
	void diff_eqs(),link_eqs();

	t0 = 0.0;  //V~[V̊Jn t=0 ɂ
	t1 = 20.0;  //V~[V̏I t=20 ɂ

	x0 = [1.0,0.0]';  //Ԃ x(0)=[1.0,0.0]' ɂ

	h = 1.0e-3; // V~[V̍1msecɂ
	dtsav = 1.0e-2;// f[^10msecɕۑ

	print "Now simulating\n";

// Ode()ɂăV~[Vs
	{TC,XC,UC} = Ode(t0,t1,x0,diff_eqs,link_eqs,h,dtsav);
// diff_eqs() ͔Lq֐
// link_eqs() ͕̔̊֌WLq֐
// TC: Ԃ̎n
// XC: x(t)̎n
// UC: o̓xNg̎n

//  l\D t, c x(t)
	mgplot(1,Array(TC),Array(XC(1,*)));
//  XC(1,*)XC1sڂ\

//  t@Cɕۑ
	print TC >> "TC.mat";
	print XC >> "XC.mat";
	print UC >> "UC.mat";
}

// diff_eqs() ͔Lq֐
Func void diff_eqs(DX,t,X,UY)
Real t;
Matrix X,DX,UY;
{
	Real K,C,M;
	Matrix xp,up,dxp;
	Matrix A,B;
	Matrix d;

//  p[^̐ݒ
	K = 1.0; C = 0.4; M = 1.0;

//  A,B̐ݒ
	A = [[0,1][-K/M,-C/M]];
	B = [0,1/M]';

	xp = X; // X xp(t)\ĂD

//  link_eqs()ŌvZUYD
//  łUY=[0]
	up = UY;

//  Od̐ݒ
	d = [0.5];

//  
	dxp = A * xp + B * (up + d);

//  ŌɑxDXɓn
	DX = [dxp];
}

// link_eqs() ͕̔̊֌WLq֐
Func void link_eqs(UY,t,X)
Real t;
Matrix UY,X;
{
	Matrix xp,up;

//  X xp(t)\ĂD
	xp = X;

//  ŌUYup̎t̒lnD
//  ł0n
	UY = [0];
}

